{ Revista ClubeDelphi
  SQLQuery (dbExpress) Design Editor
  guinther@clubedelphi.com.br }
  
unit dbxEditor;

interface

uses
 { adicione DesignIDE e DCLDB ao requires
   do package }
  SQLExpr, classes, DesignEditors, dbReg;

type
  TdbxEditor = class (TDataSetEditor)
  public
    function GetSQLQuery : TSQLQuery; 
    function GetVerbCount : integer; override;
    function GetVerb
      (Index : integer): string; override;
    procedure ExecuteVerb
      (Index : integer); override;
    procedure ConfiguraComponentes;
  end;
  procedure Register;

implementation

uses DesignIntf, uFrmdbxEditor, Controls,
  Provider,  dbClient, SysUtils,Forms, db,
   DBGrids;

{ TCdsEditor }

procedure Register;
begin
  RegisterComponentEditor(TSQLQuery,TdbxEditor);
end;

procedure TdbxEditor.ConfiguraComponentes;
var
  cds : TClientDataSet;
  dsp : TDataSetProvider;
  ds : TDataSource;
  con : TSQLConnection;
  grid : TDBGrid;
begin
  with FrmdbxEditor do
  begin
    getSQLQuery.SQL.Assign(SQLQuery.SQL);
    if rbConexaoNova.Checked then
    begin
      con := TSQLConnection.Create
        (Component.Owner);
      con.LoadParamsOnConnect := true;
      con.LoginPrompt := false;
      con.ConnectionName := cbConexaoNova.Text;
      con.Name := 'con' + cbConexaoNova.Text;  
      GetSQLQuery.SQLConnection := con;
    end;
    if rbConexaoExistente.Checked then
      GetSQLQuery.SQLConnection :=
        SQLQuery.SQLConnection;
    if cbCriarDSP.Checked then
    begin
       dsp := TDataSetProvider.Create
         (Component.Owner);
       dsp.DataSet := GetSQLQuery;
       dsp.Name := 'dsp' + TabelaSelecionada;
    end;
    if cbCriarCDS.Checked then
    begin
      cds := TClientDataSet.Create
        (Component.Owner);
      cds.Name := 'cds' + TabelaSelecionada;
      cds.ProviderName := 'dsp' +
        TabelaSelecionada;
      cds.Active := cbAtivarCDS.Checked;
    end;
    if cbCriarDS.Checked then
    begin
       ds := TDataSource.Create(Component.Owner);
       ds.Name := 'ds' + TabelaSelecionada;
       ds.DataSet := cds;
    end;
    if cbCriarDBgrid.Checked then
    begin
      grid := TDBGrid.Create(Component.Owner);
      grid.Name := 'grid'+TabelaSelecionada;
      grid.Parent :=
        Component.Owner as TWinControl;
      grid.DataSource := ds;
    end;
  end;
end;

procedure TdbxEditor.ExecuteVerb(Index: integer);
begin
  inherited;
  if Index = 1 then
  begin
    FrmdbxEditor := TFrmdbxEditor.Create(nil);
    try
      FrmdbxEditor.Component := Component; 
      if FrmdbxEditor.ShowModal = mrOk then
        ConfiguraComponentes;
    finally
      FrmdbxEditor.Free;
    end;
  end
  else
    inherited ExecuteVerb(Index);
end;

function TdbxEditor.GetVerb
  (Index: integer): string;
begin
  if index = 1 then
    result:='Configurar...'
  else
   result := inherited GetVerb(Index);
end;

function TdbxEditor.GetVerbCount: integer;
begin
  result := inherited GetVerbCount + 1;
end;

function TdbxEditor.GetSQLQuery: TSQLQuery;
begin
  result := (Component as TSQLQuery);
end;

end.
