{ Revista ClubeDelphi
  SQLQuery (dbExpress) Design Editor
  guinther@clubedelphi.com.br }
    
unit uFrmSQLQueryEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Forms, FMTBcd, DBXpress, ImgList, Controls, DB,
  DBClient, Provider, SqlExpr, Grids, DBGrids,
  StdCtrls, Buttons, ComCtrls, DesignEditors;


type
  TFrmSQLQueryEditor = class(TForm)
    SQLQuery: TSQLQuery;
    SQLConnection: TSQLConnection;
    DataSetProvider: TDataSetProvider;
    ClientDataSet: TClientDataSet;
    DataSource: TDataSource;
    ImageList: TImageList;
    btOk: TBitBtn;
    btCancelar: TBitBtn;
    pc: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lbTabelas: TListBox;
    lbColunas: TListBox;
    mmSelect: TMemo;
    GroupBox2: TGroupBox;
    cbCriarDS: TCheckBox;
    cbCriarCDS: TCheckBox;
    cbCriarDSP: TCheckBox;
    GroupBox3: TGroupBox;
    cbAtivarCDS: TCheckBox;
    cbCriarDBGrid: TCheckBox;
    btGerarSelect: TBitBtn;
    cbConexao: TComboBox;
    TabSheet2: TTabSheet;
    DBGrid1: TDBGrid;
    Label4: TLabel;
    procedure FormShow(Sender: TObject);
    procedure btGerarSelectClick(Sender: TObject);
    procedure lbTabelasClick(Sender: TObject);
    procedure pcChange(Sender: TObject);
    procedure cbConexaoChange(Sender: TObject);
    procedure Label4Click(Sender: TObject);
  private
     procedure ListaTabelas
      (ASQLConnection : TSQLConnection);
    procedure ListaColunas (ATabela : string);
  public
    { declare DesignEditors no uses }
    Editor : TComponentEditor;
    TabelaSelecionada : string;
    Component : TComponent;
  end;

var
  FrmSQLQueryEditor: TFrmSQLQueryEditor;

implementation

{$R *.dfm}

uses ShellApi;

procedure TFrmSQLQueryEditor.FormShow
  (Sender: TObject);
var
  i,c : integer;
begin
  cbConexao.Items.Add('<New connection>');
  c := Component.Owner.ComponentCount - 1;
  for i := 0 to c do
    if Component.Owner.Components[i] is
      TSQLConnection then
      cbConexao.Items.add
        (Component.Owner.Components[i].Name);
end;

procedure TFrmSQLQueryEditor.ListaTabelas
  (ASQLConnection: TSQLConnection);
begin
  lbTabelas.Items.Clear;
  ASQLConnection.GetTableNames(lbTabelas.Items);
  if lbTabelas.Items.Count > 0 then
  begin
     lbTabelas.ItemIndex := 0;
     lbTabelasClick(nil);
     btGerarSelectClick(nil);
  end;
end;

procedure TFrmSQLQueryEditor.btGerarSelectClick
  (Sender: TObject);
var
  i : integer;
  Cols : string;
begin
  for i := 0 to lbColunas.Items.Count - 1 do
    if lbColunas.Selected[i] then
      Cols := Cols + lbColunas.Items[i] + ',';
  Delete(Cols,length(Cols),1);
  mmSelect.Lines.Text := 
    (Format('select %s from %s',[Cols,
      lbTabelas.Items[lbTabelas.ItemIndex]]));
  SQLQuery.SQL.Assign(mmSelect.Lines);
end;

procedure TFrmSQLQueryEditor.ListaColunas
  (ATabela: string);
begin
  lbColunas.Clear;
  SQLQuery.SQLConnection.GetFieldNames
    (ATabela,lbColunas.Items);
  lbColunas.Items.Insert(0,'*');
  lbColunas.Selected[0] := true;
end;

procedure TFrmSQLQueryEditor.lbTabelasClick
  (Sender: TObject);
begin
  TabelaSelecionada :=
    lbTabelas.Items[lbTabelas.ItemIndex];
  ListaColunas(TabelaSelecionada);
  btGerarSelectClick(nil);
end;

procedure TFrmSQLQueryEditor.pcChange
  (Sender: TObject);
begin
  if pc.ActivePageIndex = 1 then
  begin
    ClientDataSet.Close;
    ClientDataSet.Open;
  end;
end;

procedure TFrmSQLQueryEditor.cbConexaoChange
  (Sender: TObject);
var
  con : TComponent;
begin
  SQLQuery.SQLConnection := nil;
  if cbConexao.ItemIndex = 0 then // nova
  begin
    { chama editor de conexes do dbExpress }
    GetComponentEditor(SQLConnection,
      Editor.Designer).Edit;
    if SQLConnection.ConnectionName <> '' then
      SQLQuery.SQLConnection := SQLConnection
    else
      cbConexao.ItemIndex := -1;
  end
  else // escolheu conexo da lista
  begin
    con := Component.owner.FindComponent
      (cbConexao.Text);
    SQLQuery.SQLConnection := TSQLConnection(con);
  end;
  if SQLQuery.SQLConnection <> nil then
    ListaTabelas(SQLQuery.SQLConnection);
end;

procedure TFrmSQLQueryEditor.Label4Click(Sender: TObject);
var
 email : string;
begin
 email:='guinther@clubedelphi.com.br';
 ShellExecute(handle,nil,PChar('mailto:'+email),nil,nil, SW_SHOWNORMAL);
end;

end.


