{ Revista ClubeDelphi
  SQLQuery (dbExpress) Design Editor
  guinther@clubedelphi.com.br }
  
unit uSQLQueryEditor;

interface

uses
 { adicione DesignIDE e DCLDB ao requires
   do package }
  SQLExpr, classes, DesignEditors, dbReg;

type
  TSQLQueryEditor = class (TDataSetEditor)
  private
    procedure ConfiguraComponentes;
    function GetSQLQuery : TSQLQuery;
  public
    procedure Edit; override;
    function GetVerbCount : integer; override;
    function GetVerb
      (Index : integer): string; override;
    procedure ExecuteVerb
      (Index : integer); override;

  end;
  procedure Register;

implementation

uses db, Provider,  dbClient, DBGrids, DesignIntf,
  uFrmSQLQueryEditor, Forms, Controls;

{ TCdsEditor }

procedure Register;
begin
  RegisterComponentEditor(TSQLQuery,TSQLQueryEditor);
end;

{ declare DBClient, DB, Provider, DBGrids, Forms
  e Controls no uses}
procedure TSQLQueryEditor.ConfiguraComponentes;
var
  cds : TClientDataSet;
  dsp : TDataSetProvider;
  ds : TDataSource;
  con : TSQLConnection;
  grid : TDBGrid;
begin
  with FrmSQLQueryEditor do
  begin
    getSQLQuery.SQL.Assign(SQLQuery.SQL);
    { se foi criada uma conexo } 
    if SQLQuery.SQLConnection = SQLConnection then
    begin
      con := TSQLConnection.Create
        (Component.Owner);
      con.LoadParamsOnConnect := true;
      con.LoginPrompt := false;
      con.ConnectionName := SQLConnection.ConnectionName;
      con.Name := 'con' + con.ConnectionName;
      GetSQLQuery.SQLConnection := con;
    end
    else
      GetSQLQuery.SQLConnection :=
        SQLQuery.SQLConnection;
    if cbCriarDSP.Checked then
    begin
       dsp := TDataSetProvider.Create
         (Component.Owner);
       dsp.DataSet := GetSQLQuery;
       dsp.Name := 'dsp' + TabelaSelecionada;
    end;
    if cbCriarCDS.Checked then
    begin
      cds := TClientDataSet.Create
        (Component.Owner);
      cds.Name := 'cds' + TabelaSelecionada;
      cds.ProviderName := 'dsp' +
        TabelaSelecionada;
      cds.Active := cbAtivarCDS.Checked;
    end;
    if cbCriarDS.Checked then
    begin
       ds := TDataSource.Create(Component.Owner);
       ds.Name := 'ds' + TabelaSelecionada;
       ds.DataSet := cds;
    end;
    if cbCriarDBgrid.Checked then
    begin
      grid := TDBGrid.Create(Component.Owner);
      grid.Name := 'grid'+TabelaSelecionada;
      grid.Parent :=
        Component.Owner as TForm;
      grid.DataSource := ds;
    end;
  end;
end;

procedure TSQLQueryEditor.ExecuteVerb(Index: integer);
begin
  inherited;
  if Index = 1 then
  begin
    { declare uFrmSQLQueryEditor no uses }
    FrmSQLQueryEditor :=
      TFrmSQLQueryEditor.Create(nil);
    try
      FrmSQLQueryEditor.Component := Component;
      FrmSQLQueryEditor.Editor := self;      
      if FrmSQLQueryEditor.ShowModal = mrOk then
        ConfiguraComponentes;
    finally
      FrmSQLQueryEditor.Free;
    end;
  end
  else
    inherited ExecuteVerb(Index);
end;

function TSQLQueryEditor.GetVerb
  (Index: integer): string;
begin
  if index = 1 then
    result := 'Config...'
  else
   result := inherited GetVerb(Index);
end;

function TSQLQueryEditor.GetVerbCount: integer;
begin
  result := inherited GetVerbCount + 1;
end;

function TSQLQueryEditor.GetSQLQuery: TSQLQuery;
begin
  result := (Component as TSQLQuery);
end;

procedure TSQLQueryEditor.Edit;
begin
  ExecuteVerb(1);
end;

end.
